//=============================================================================
//
// file :         DiffractometerClass.h
//
// description :  Include for the DiffractometerClass root class.
//                This class is represents the singleton class for
//                the Diffractometer device class.
//                It contains all properties and methods which the 
//                Diffractometer requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _DIFFRACTOMETERCLASS_H
#define _DIFFRACTOMETERCLASS_H

#include <tango.h>
#include <Diffractometer.h>


namespace Diffractometer_ns
{//=====================================
//	Define classes for attributes
//=====================================
class UBAttrib: public Tango::ImageAttr
{
public:
	UBAttrib():ImageAttr("UB", Tango::DEV_DOUBLE, Tango::READ, 3, 3) {};
	~UBAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_UB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_UB_allowed(ty);}
};

class ReflectionsAnglesAttrib: public Tango::ImageAttr
{
public:
	ReflectionsAnglesAttrib():ImageAttr("ReflectionsAngles", Tango::DEV_DOUBLE, Tango::READ, 2000, 2000) {};
	~ReflectionsAnglesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_ReflectionsAngles(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_ReflectionsAngles_allowed(ty);}
};

class ReflectionsAttrib: public Tango::ImageAttr
{
public:
	ReflectionsAttrib():ImageAttr("Reflections", Tango::DEV_DOUBLE, Tango::READ_WRITE, 12, 50) {};
	~ReflectionsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Reflections(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Reflections(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Reflections_allowed(ty);}
};

class AnglesRangeCheckAttrib: public Tango::ImageAttr
{
public:
	AnglesRangeCheckAttrib():ImageAttr("AnglesRangeCheck", Tango::DEV_BOOLEAN, Tango::READ, 20, 1000) {};
	~AnglesRangeCheckAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AnglesRangeCheck(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AnglesRangeCheck_allowed(ty);}
};

class AnglesDegeneratedAttrib: public Tango::ImageAttr
{
public:
	AnglesDegeneratedAttrib():ImageAttr("AnglesDegenerated", Tango::DEV_BOOLEAN, Tango::READ, 20, 1000) {};
	~AnglesDegeneratedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AnglesDegenerated(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AnglesDegenerated_allowed(ty);}
};

class AnglesAttrib: public Tango::ImageAttr
{
public:
	AnglesAttrib():ImageAttr("Angles", Tango::DEV_DOUBLE, Tango::READ, 20, 1000) {};
	~AnglesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Angles(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Angles_allowed(ty);}
};

class pseudoAxesProxiesAttrib: public Tango::SpectrumAttr
{
public:
	pseudoAxesProxiesAttrib():SpectrumAttr("pseudoAxesProxies", Tango::DEV_STRING, Tango::READ, 100) {};
	~pseudoAxesProxiesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_pseudoAxesProxies(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_pseudoAxesProxies_allowed(ty);}
};

class AxesNamesAttrib: public Tango::SpectrumAttr
{
public:
	AxesNamesAttrib():SpectrumAttr("AxesNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~AxesNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AxesNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AxesNames_allowed(ty);}
};

class CrystalNamesAttrib: public Tango::SpectrumAttr
{
public:
	CrystalNamesAttrib():SpectrumAttr("CrystalNames", Tango::DEV_STRING, Tango::READ, 100) {};
	~CrystalNamesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_CrystalNames(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_CrystalNames_allowed(ty);}
};

class SimulatedAttrib: public Tango::Attr
{
public:
	SimulatedAttrib():Attr("Simulated", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~SimulatedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Simulated(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Simulated(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Simulated_allowed(ty);}
};

class GammaStarAttrib: public Tango::Attr
{
public:
	GammaStarAttrib():Attr("GammaStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~GammaStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_GammaStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_GammaStar_allowed(ty);}
};

class BetaStarAttrib: public Tango::Attr
{
public:
	BetaStarAttrib():Attr("BetaStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~BetaStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_BetaStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_BetaStar_allowed(ty);}
};

class AlphaStarAttrib: public Tango::Attr
{
public:
	AlphaStarAttrib():Attr("AlphaStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~AlphaStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AlphaStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AlphaStar_allowed(ty);}
};

class CStarAttrib: public Tango::Attr
{
public:
	CStarAttrib():Attr("CStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~CStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_CStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_CStar_allowed(ty);}
};

class BStarAttrib: public Tango::Attr
{
public:
	BStarAttrib():Attr("BStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~BStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_BStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_BStar_allowed(ty);}
};

class AStarAttrib: public Tango::Attr
{
public:
	AStarAttrib():Attr("AStar", Tango::DEV_DOUBLE, Tango::READ) {};
	~AStarAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AStar(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AStar_allowed(ty);}
};

class UzFitAttrib: public Tango::Attr
{
public:
	UzFitAttrib():Attr("UzFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~UzFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_UzFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_UzFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_UzFit_allowed(ty);}
};

class UzAttrib: public Tango::Attr
{
public:
	UzAttrib():Attr("Uz", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UzAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Uz(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Uz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Uz_allowed(ty);}
};

class UyFitAttrib: public Tango::Attr
{
public:
	UyFitAttrib():Attr("UyFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~UyFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_UyFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_UyFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_UyFit_allowed(ty);}
};

class UyAttrib: public Tango::Attr
{
public:
	UyAttrib():Attr("Uy", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Uy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Uy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Uy_allowed(ty);}
};

class UxFitAttrib: public Tango::Attr
{
public:
	UxFitAttrib():Attr("UxFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~UxFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_UxFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_UxFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_UxFit_allowed(ty);}
};

class UxAttrib: public Tango::Attr
{
public:
	UxAttrib():Attr("Ux", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~UxAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Ux(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Ux(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Ux_allowed(ty);}
};

class GammaFitAttrib: public Tango::Attr
{
public:
	GammaFitAttrib():Attr("GammaFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~GammaFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_GammaFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_GammaFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_GammaFit_allowed(ty);}
};

class GammaAttrib: public Tango::Attr
{
public:
	GammaAttrib():Attr("Gamma", Tango::DEV_DOUBLE, Tango::READ) {};
	~GammaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Gamma(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Gamma_allowed(ty);}
};

class BetaFitAttrib: public Tango::Attr
{
public:
	BetaFitAttrib():Attr("BetaFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~BetaFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_BetaFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_BetaFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_BetaFit_allowed(ty);}
};

class BetaAttrib: public Tango::Attr
{
public:
	BetaAttrib():Attr("Beta", Tango::DEV_DOUBLE, Tango::READ) {};
	~BetaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Beta(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Beta_allowed(ty);}
};

class AlphaFitAttrib: public Tango::Attr
{
public:
	AlphaFitAttrib():Attr("AlphaFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AlphaFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AlphaFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_AlphaFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AlphaFit_allowed(ty);}
};

class AlphaAttrib: public Tango::Attr
{
public:
	AlphaAttrib():Attr("Alpha", Tango::DEV_DOUBLE, Tango::READ) {};
	~AlphaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Alpha(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Alpha_allowed(ty);}
};

class CFitAttrib: public Tango::Attr
{
public:
	CFitAttrib():Attr("CFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~CFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_CFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_CFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_CFit_allowed(ty);}
};

class CAttrib: public Tango::Attr
{
public:
	CAttrib():Attr("C", Tango::DEV_DOUBLE, Tango::READ) {};
	~CAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_C(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_C_allowed(ty);}
};

class BFitAttrib: public Tango::Attr
{
public:
	BFitAttrib():Attr("BFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~BFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_BFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_BFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_BFit_allowed(ty);}
};

class BAttrib: public Tango::Attr
{
public:
	BAttrib():Attr("B", Tango::DEV_DOUBLE, Tango::READ) {};
	~BAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_B(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_B_allowed(ty);}
};

class AFitAttrib: public Tango::Attr
{
public:
	AFitAttrib():Attr("AFit", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AFitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AFit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_AFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AFit_allowed(ty);}
};

class AAttrib: public Tango::Attr
{
public:
	AAttrib():Attr("A", Tango::DEV_DOUBLE, Tango::READ) {};
	~AAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_A(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_A_allowed(ty);}
};

class CrystalAttrib: public Tango::Attr
{
public:
	CrystalAttrib():Attr("Crystal", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~CrystalAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_Crystal(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_Crystal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_Crystal_allowed(ty);}
};

class WaveLengthAttrib: public Tango::Attr
{
public:
	WaveLengthAttrib():Attr("WaveLength", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~WaveLengthAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_WaveLength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_WaveLength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_WaveLength_allowed(ty);}
};

class AutoUpdateFromProxiesAttrib: public Tango::Attr
{
public:
	AutoUpdateFromProxiesAttrib():Attr("AutoUpdateFromProxies", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AutoUpdateFromProxiesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AutoUpdateFromProxies(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_AutoUpdateFromProxies(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AutoUpdateFromProxies_allowed(ty);}
};

class AnglesIdxAttrib: public Tango::Attr
{
public:
	AnglesIdxAttrib():Attr("AnglesIdx", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~AnglesIdxAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Diffractometer *>(dev))->read_AnglesIdx(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Diffractometer *>(dev))->write_AnglesIdx(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Diffractometer *>(dev))->is_AnglesIdx_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class SetCrystalParameterValuesClass : public Tango::Command
{
public:
	SetCrystalParameterValuesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetCrystalParameterValuesClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetCrystalParameterValuesClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_SetCrystalParameterValues_allowed(any);}
};



class SaveClass : public Tango::Command
{
public:
	SaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_Save_allowed(any);}
};



class RemoveReflectionClass : public Tango::Command
{
public:
	RemoveReflectionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RemoveReflectionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RemoveReflectionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_RemoveReflection_allowed(any);}
};



class LoadClass : public Tango::Command
{
public:
	LoadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_Load_allowed(any);}
};



class GetCrystalParameterValuesCmd : public Tango::Command
{
public:
	GetCrystalParameterValuesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCrystalParameterValuesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCrystalParameterValuesCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_GetCrystalParameterValues_allowed(any);}
};



class DeleteCurrentCrystalClass : public Tango::Command
{
public:
	DeleteCurrentCrystalClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeleteCurrentCrystalClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeleteCurrentCrystalClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_DeleteCurrentCrystal_allowed(any);}
};



class CopyReflectionToCmd : public Tango::Command
{
public:
	CopyReflectionToCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CopyReflectionToCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CopyReflectionToCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_CopyReflectionTo_allowed(any);}
};



class CopyCurrentCrystalAsClass : public Tango::Command
{
public:
	CopyCurrentCrystalAsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CopyCurrentCrystalAsClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CopyCurrentCrystalAsClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_CopyCurrentCrystalAs_allowed(any);}
};



class ConfigureCrystalCmd : public Tango::Command
{
public:
	ConfigureCrystalCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ConfigureCrystalCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ConfigureCrystalCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_ConfigureCrystal_allowed(any);}
};



class ComputeUCmd : public Tango::Command
{
public:
	ComputeUCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ComputeUCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ComputeUCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_ComputeU_allowed(any);}
};



class AffineCrystalCmd : public Tango::Command
{
public:
	AffineCrystalCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AffineCrystalCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AffineCrystalCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_AffineCrystal_allowed(any);}
};



class AddReflectionClass : public Tango::Command
{
public:
	AddReflectionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AddReflectionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AddReflectionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_AddReflection_allowed(any);}
};



class AddNewCrystalClass : public Tango::Command
{
public:
	AddNewCrystalClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AddNewCrystalClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AddNewCrystalClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_AddNewCrystal_allowed(any);}
};



class AbortCmd : public Tango::Command
{
public:
	AbortCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AbortCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AbortCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Diffractometer *>(dev))->is_Abort_allowed(any);}
};



//
// The DiffractometerClass singleton definition
//

class DiffractometerClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static DiffractometerClass *init(const char *);
	static DiffractometerClass *instance();
	~DiffractometerClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	DiffractometerClass(string &);
	static DiffractometerClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Diffractometer_ns

#endif // _DIFFRACTOMETERCLASS_H
